//  The implementation of the |Key| class follows.

#include "EvalState.h"

Key::~Key(VOID) {
   if (inout)
      error("deleting a dictionary entry---with tasks still waiting?!!") ;
   if (val)
      delete val ;
   delete waiting ;
}

void Key::addTask(class EvalState *es) {
   waiting->append(es->ESlink()) ;
}

class EvalState *Key::getFirstTask(VOID) {
   link *l = waiting->first() ;
   if (l) {
      l->removeNoDealloc() ;
      return (EvalState *)l->element() ;
   } else
      return 0 ;
}
