(define (prime-aux a b)
   (if (> (* b b) a) #t
       (if (= a (* b (/ a b))) #f
           (prime-aux a (+ b 2)))))
;
(define (prime a)
   (prime-aux a 3))
;
(define (send-pairs key n)
   (out key n)
   (send-pairs key (+ n 2)))
;
(define (prime-task key)
   (let ((p (in key)))
      (if (prime p)
          (display p " "))
      (prime-task key)))
;
(let ((key (make-key)))
   (par
      (lambda () (prime-task key))
      (lambda () (prime-task key))
      (lambda () (prime-task key))
      (lambda () (prime-task key))
      (lambda () (send-pairs key 3))))
