;
;   And, done by if's.
;
(defmacro (and . b)
   (if b
       (let ((first (car b))
             (rest (cdr b)))
          (if rest
             (if (atom? first)
                `(if ,first (and . ,rest) ())
                (let ((g (gensym)))
                   `(let ((,g ,first))
                       (if ,g (and . ,rest) ()))))
              first))
          '#t))
;
;   Or, done by if's.
;
(defmacro (or . b)
   (if b
       (let ((first (car b))
             (rest (cdr b)))
          (if rest
             (if (atom? first)
                `(if ,first '#t (or . ,rest))
                (let ((g (gensym)))
                   `(let ((,g ,first))
                       (if ,g '#t (or . ,rest)))))
              first))
          '()))
