(define (2n a)
   (if (<= a 0) 1 (* 2 (2n (- a 1)))))
;
(define (start a n)
   (let loop ((ar (make-array (+ n 1)))
         (i 0))
      (if (> i n) ar
          (begin
             (aset ar i (+ a i))
             (loop ar (+ i 1))))))
;
(define (nextlev nar ar xorv len)
   (let loop ((i 0))
      (if (> i len) nar
          (begin
             (aset nar i (+ (aref ar i) (aref ar (lxor i xorv))))
             (loop (+ i 1))))))
;
(define (make ar xorv len)
   (if (> xorv len)
       0
       (let ((nar (make-array (+ len 1))))
          (make (nextlev nar ar xorv len) (* xorv 2) len))))
;
(define (bf a)
   (let ((pow (- (2n *n*) 1)))
      (make (start a pow) 1 pow)))
;
(define (test n)
   (define *n* n)
   (display n "\n")
   (time (define g (makegraph bf)))
   (time (define w (window g))))
;
(define (tst)
   (let loop ((n 1))
      (test n)
      (loop (+ n 1))))
