(define (aref a n)
   (if (<= n 0) (car a) (aref (cdr a) (- n 1))))
;
(define (xor a b)
   (if (= a 0) b
       (if (= b 0) a
           (+ (* 2 (xor (/ a 2) (/ b 2)))
              (if (eq (odd a) (odd b)) 0 1)))))
;
(define (2n a)
   (if (<= a 0) 1 (* 2 (2n (- a 1)))))
;
(define (start a n)
   (if (< n 0) ()
       (cons (+ a n) (start a (- n 1)))))
;
(define (nextlev ar xorv len)
   (if (< len 0) ()
      (cons (+ (aref ar len) (aref ar (xor len xorv)))
            (nextlev ar xorv (- len 1)))))
;
(define (make ar xorv len)
   (if (> xorv len)
       0
       (make (nextlev ar xorv len) (* xorv 2) len)))
;
(define (bf a)
   (let ((pow (- (2n *n*) 1)))
      (make (start a pow) 1 pow)))
;
(define (test n)
   (define *n* n)
   (display n "\n")
   (time (define g (makegraph bf)))
   (time (define w (window g))))
;
(define (tst)
   (let loop ((n 1))
      (test n)
      (loop (+ n 1))))
