(define (lattice a b x y)
   (if (<= x 0)
      (if (<= y 0)
         (let* ((front (list (+ a b))))
            (cons front front))
         (let* ((sublattice (lattice a b x (- y 1)))
                (front (adddown (cdr sublattice) b)))
            (cons (cons (car front) (car sublattice)) front)))
   (let* ((sublattice (lattice a b (- x 1) y))
          (front (adddown (car sublattice) a)))
      (cons front (cons (car front) (cdr sublattice))))))
;
(define (adddown l b)
   (if l
      (let* ((f (adddown (cdr l) b))
             (r (+ (car l) (if f (car f) b))))
         (cons r f))
      ()))
;
(define (foo a b)
   (car (car (lattice a b n n))))
;
(define n 16)
(ps-to-file (makegraph foo) "foo.ps")
