;
;   Timing information for a read cycle.
;
(load "quick.hs")
(define (time a b c)
   (->q (strcat cycle "-" a) (strcat cycle "-" b)))
;
(define RL2 'RL)
(define CL2 'CL)
;
(define cycle 'R)
;
(time 'RL RL2 'tc-rd)
(time 'RL 'RH 'tw-RL)
(time 'CL 'RH 'td-CLRH)
(time 'RL 'CL 'td-RLCL)
(time 'RH RL2 'tw-RH)
(time 'RL 'CH 'td-RLCH)
(time 'CL 'CH 'tw-CL)
(time 'CH RL2 'td-CHRL)
(time 'CA 'CL 'tsu-CA)
(time 'CH CL2 'tw-CH)
(time 'RA 'RL 'tsu-RA)
(time 'RL 'ERA 'th-RA)
(time 'CA 'CH 'td-CACH)
(time 'CA 'RH 'td-CARH)
(time 'RL 'CA 'td-RLCA)
(time 'W 'CL 'tsu-rd)
(time 'CL 'ECA 'th-CLCA)
(time 'CH 'EW 'th-CHrd)
(time 'RH 'EW 'th-RHrd)
(time 'CL 'Q 'ta-C)
(time 'CA 'Q 'ta-CA)
(time 'CA 'EQ 'tdis-CH)
(time 'RL 'Q 'ta-R)
;
(time 'Q 'EQ '-)
;
(time 'ERA 'CA '-)
;
;   backloops
;
(time 'EW 'W '-)
(time 'EQ 'Q '-)
(time 'ECA 'RA '-)
;
(define cycle 'EW)
(time 'RL RL2 'tc-W)
(time 'RL 'RH 'tw-RL)
(time 'CL 'RH 'td-CLRH)
(time 'RL 'CL 'td-RLCL)
(time 'RH RL2 'tw-RH)
(time 'RL 'CH 'td-RLCH)
(time 'CL 'CH 'tw-CL)
(time 'CH RL2 'td-CHRL)
(time 'CA 'CL 'tsu-CA)
(time 'CH CL2 'tw-CH)
(time 'RA 'RL 'tsu-RA)
(time 'RL 'ERA 'th-RA)
(time 'CA 'CH 'td-CACH)
(time 'CA 'RH 'td-CARH)
(time 'RL 'CA 'td-RLCA)
(time 'W 'CL 'tsu-WCL)
(time 'W 'CH 'tsu-WCH)
(time 'W 'RH 'tsu-WRH)
(time 'RL 'EW 'th-RLW)
(time 'CL 'EW 'th-CLW)
(time 'W 'EW 'tw-WL)
(time 'CL 'ECA 'th-CLCA)
(time 'RL 'EDAT 'th-RLD)
(time 'CL 'EDAT 'th-D)
(time 'D 'CL 'tsu-D)
;
(time 'ERA 'CA '-)
;
;   backloops
;
(time 'EW 'W '-)
(time 'EDAT 'DAT '-)
(time 'ECA 'RA '-)

(define cycle 'W)
(time 'RL RL2 'tc-W)
(time 'RL 'RH 'tw-RL)
(time 'CL 'RH 'td-CLRH)
(time 'RL 'CL 'td-RLCL)
(time 'RH RL2 'tw-RH)
(time 'RL 'CH 'td-RLCH)
(time 'CL 'CH 'tw-CL)
(time 'CH RL2 'td-CHRL)
(time 'CA 'CL 'tsu-CA)
(time 'CH CL2 'tw-CH)
(time 'RA 'RL 'tsu-RA)
(time 'RL 'ERA 'th-RA)
(time 'CA 'CH 'td-CACH)
(time 'CA 'RH 'td-CARH)
(time 'RL 'CA 'td-RLCA)
(time 'W 'CH 'tsu-WCH)
(time 'W 'RH 'tsu-WRH)
(time 'RL 'EW 'th-RLW)
(time 'CL 'EW 'th-CLW)
(time 'W 'EW 'tw-WL)
(time 'CL 'ECA 'th-CLCA)
(time 'RL 'EDAT 'th-RLD)
(time 'CL 'EDAT 'th-D)
(time 'D 'CL 'tsu-D)
(time 'CH 'EQ 't-disCH)
(time 'CL 'Q 'ta-C)
(time 'CA 'Q 'ta-CA)
(time 'RL 'Q 'ta-R)
;
(time 'ERA 'CA '-)
;
;   backloops
;
(time 'EW 'W '-)
(time 'EDAT 'DAT '-)
(time 'EQ 'Q '-)
(time 'ECA 'RA '-)
(time 'W 'RH 'tsu-WRH)
(time 'RL 'EW 'th-RLW)
(time 'CL 'EW 'th-CLW)
(time 'W 'EW 'tw-WL)
(time 'RL 'EDAT 'th-RLD)
(time 'CL 'EDAT 'th-D)
(time 'D 'CL 'tsu-D)
;
(time 'ERA 'CA '-)
;
;   backloops
;
(time 'EW 'W '-)
(time 'EDAT 'DAT '-)
(time 'ECA 'RA '-)

(define cycle 'RMW)
(time 'RL RL2 'tc-rdW)
(time 'RL 'RH 'tw-RL)
(time 'CL 'RH 'td-CLRH)
(time 'RL 'CL 'td-RLCL)
(time 'RH RL2 'tw-RH)
(time 'RL 'CH 'td-RLCH)
(time 'CL 'CH 'tw-CL)
(time 'CH RL2 'td-CHRL)
(time 'CA 'CL 'tsu-CA)
(time 'CH CL2 'tw-CH)
(time 'RA 'RL 'tsu-RA)
(time 'RL 'ERA 'th-RA)
(time 'CA 'CH 'td-CACH)
(time 'CA 'RH 'td-CARH)
(time 'RL 'CA 'td-RLCA)
(time 'WH 'CL 'tsu-rd)
(time 'CA 'WL 'td-CAWL)
(time 'CL 'WL 'td-CLWL)
(time 'RL 'WL 'td-RLWL)
(time 'WL 'WH2 'tw-WL)
(time 'WL 'CH 'tsu-WCH)
(time 'WL 'RH 'tsu-WRH)
(time 'CL 'ECA 'th-CLCA)
(time 'DAT 'CL 'tsu-D)
(time 'WL 'EDAT 'th-D)
(time 'CH 'EQ 't-disCH)
(time 'CL 'Q 'ta-C)
(time 'CA 'Q 'ta-CA)
(time 'RL 'Q 'ta-R)
;
(time 'ERA 'CA '-)
;
;   backloops
;
(time 'WH2 'WH '-)
(time 'EDAT 'DAT '-)
(time 'EQ 'Q '-)
(time 'ECA 'RA '-)

(update)
