(define *g* (newgraph))
(define *radix* 10)
(define (check-str a)
   (if (num? a)
       (num->str a *radix*)
       a))
(define (added a b)
   (let ((a (check-str a))
         (b (check-str b)))
      (addnode *g* a)
      (addnode *g* b)
      (addedge *g* a b)
      (define w (window *g*))))
(define (-> a . b)
   (let loop ((b b))
      (if b
         (begin
            (added a (car b))
            (loop (cdr b))))))
(define (addedq a b)
   (let ((a (check-str a))
         (b (check-str b)))
      (addnode *g* a)
      (addnode *g* b)
      (addedge *g* a b)))
(define (->q a . b)
   (let loop ((b b))
      (if b
         (begin
            (addedq a (car b))
            (loop (cdr b))))))
(define (update) (define w (window *g*)))
(define (new) (set! *g* (newgraph)))
